#include <stdlib.h>
#include <string.h>

static struct
{
	void (*initcall)();	/* initcall function pointer */
	char *tag;		/* tag to identify initcall */
	char **run_first_list;	/* initcalls to be run before this initcall */
} initcalls[20];

static int num_initcalls=0;

void register_initcall(
	void (*initcall)(),
	char *tag,
	char **run_first_list
	)
{
	initcalls[num_initcalls].initcall=initcall;
	initcalls[num_initcalls].tag=tag;
	initcalls[num_initcalls].run_first_list=run_first_list;
	num_initcalls++;
}

int tag_to_index(char *tag)
{
	int i;
	for (i=0; i<num_initcalls; i++)
		if (strcmp(tag, initcalls[i].tag) == 0) return(i);
}

void do_initcall(int i)
{
	int j=0;
	if (initcalls[i].initcall == NULL) return;  /* done already */
	while (initcalls[i].run_first_list[j] != NULL)
		do_initcall(tag_to_index(initcalls[i].run_first_list[j++]));
	initcalls[i].initcall();
	initcalls[i].initcall=NULL; /* flag done */
}

void do_initcalls()
{
	int i;
	for (i=0; i<num_initcalls; i++)
		do_initcall(i);
}

extern void register_foo1_initcall();
extern void register_foo2_initcall();
extern void register_foo3_initcall();
extern void register_foo4_initcall();

main()
{
	register_foo1_initcall();
	register_foo2_initcall();
	register_foo3_initcall();
	register_foo4_initcall();

	do_initcalls();
}
